#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <math.h>

using namespace std;

int main(int argn, char** argv)
{
    ifstream file;
    file.open("pair.txt");

    int pair_num = atoi(argv[1]);
    int** pair = new int*[pair_num];       
    for(int n = 0; n < pair_num; n ++)
    {
       pair[n] = new int[2];
       file >> pair[n][0] >> pair[n][1];
    }
    file.close();

    int spoint_num = atoi(argv[2]);
    int tpoint_num = atoi(argv[3]);
    double **points = new double*[spoint_num];
    file.open("points.txt");
    for(int n = 0; n < spoint_num; n ++)
    {
        points[n] = new double[2];
        file >> points[n][0] >> points[n][1];
    }
    file.close();

    double *areas = new double[spoint_num];
    file.open("areas.txt");
    for(int n = 0; n < spoint_num; n ++)
    {
        file >> areas[n];
    }
    file.close();

    double *areat = new double[tpoint_num];
    file.open("areat.txt");
    for(int n = 0; n < tpoint_num; n ++)
    {   
        file >> areat[n];
    }
    file.close();


    double** cost = new double*[spoint_num]; 
    int *cnum = new int[spoint_num];      
    for(int n = 0; n < spoint_num; n ++)
    {
       char str[100];
       sprintf(str, "cost%d.txt", n+1);
       file.open(str); 
       int clen;
       file >> clen;
       //cout << clen << " ";
       cnum[n] = clen;
       cost[n] = new double[clen];
       for(int m = 0; m < clen; m ++)
          file >> cost[n][m];
       file.close();
    }

    double*** pointt = new double**[spoint_num];
    int* pt_num = new int[spoint_num];       
    for(int n = 0; n < spoint_num; n ++)
    {       
       char str[100];
       sprintf(str, "pointt%d.txt", n+1);
       file.open(str); 
       int clen;
       file >> clen;
       pt_num[n] = clen;
       pointt[n] = new double*[clen];       
       for(int m = 0; m < clen; m ++)
       {
         pointt[n][m] = new double[2];
         file >> pointt[n][m][0] >> pointt[n][m][1];
       }
       file.close();
    }

    
   int ncon = 1;  
   for(int p = 0; p < pair_num; p++)
   {
        char fn[100];
        sprintf(fn, "cx%d.txt", ncon);
        ncon ++;
        FILE *fd = fopen(fn, "wt");
        
        int i = pair[p][0]-1;
        int j = pair[p][1]-1;
        for (int m = 0; m < cnum[i]; m++)
        {
           for (int n = 0; n < cnum[j]; n++)
           {
             double a = atan2(pointt[i][m][1] - pointt[j][n][1],
                              pointt[i][m][0] - pointt[j][n][0]);
             double b = atan2(points[i][1] - points[j][1],
                              points[i][0] - points[j][0]);
             double c = cos(a - b);
             fprintf(fd, "%f ", c);       
           }
           fprintf(fd, "\n");  
        }
        fclose(fd);      
   }

   for(int p = 0; p < pair_num; p++)
   {
        char fn[100];
        sprintf(fn, "cx%d.txt", ncon);
        ncon ++;
        FILE *fd = fopen(fn, "wt");

        int i = pair[p][0]-1;
        int j = pair[p][1]-1;
        for (int m = 0; m < cnum[i]; m++)
        {
          for (int n = 0; n < cnum[j]; n++)
          {
             double a = atan2(pointt[i][m][1] - pointt[j][n][1],
                              pointt[i][m][0] - pointt[j][n][0]);
             double b = atan2(points[i][1] - points[j][1],
                              points[i][0] - points[j][0]);
             double c = sin(a - b);
             fprintf(fd, "%f ", c);                 
          }
           fprintf(fd, "\n");        
        }

        fclose(fd);
   }


   for(int p = 0; p < pair_num; p++)
   {
        char fn[100];
        sprintf(fn, "cx%d.txt", ncon);
        ncon ++;
        FILE *fd = fopen(fn, "wt");

        int i = pair[p][0]-1;
        int j = pair[p][1]-1;
        for (int m = 0; m < cnum[i]; m++)
        {
           for (int n = 0; n < cnum[j]; n++)
           {
             double a = sqrt((pointt[i][m][1] - pointt[j][n][1]) * (pointt[i][m][1] - pointt[j][n][1]) +
                             (pointt[i][m][0] - pointt[j][n][0]) * (pointt[i][m][0] - pointt[j][n][0]));
             double b = sqrt((points[i][1] - points[j][1]) * (points[i][1] - points[j][1]) + 
                             (points[i][0] - points[j][0]) * (points[i][0] - points[j][0]));
             double c = a/b;
             fprintf(fd, "%f ", c);
           }
           fprintf(fd, "\n");
        }

        fclose(fd);

   }


 
    // Clean up
    for(int n = 0; n < pair_num; n ++)
    {
        delete[] pair[n];
    } 
    delete[] pair;

    for(int n = 0; n < spoint_num; n ++)
    {
        delete[] points[n];
    }
    delete[] points;

    for(int n = 0; n < spoint_num; n ++)
    {
        delete[] cost[n];
    }
    delete[] cost;
    delete[] cnum;  

    for(int n = 0; n < spoint_num; n ++)
    {       
       for(int m = 0; m < pt_num[n]; m ++)
       {
         delete[] pointt[n][m];
       }
       delete[] pointt[n];
    }
    delete[] pointt;
    delete[] pt_num;

     return 0;
}
 
