function localcosts
seg1 = load('seg1.txt');
sid = unique(seg1);
N = size(sid,1);

im1 = imread('image1.ppm');
im1 = im2double(im1);
im2 = imread('image2.ppm');
im2 = im2double(im2);
%bw = roipoly(im1);
%save bw.mat bw
load bw.mat

sregion = [];
spoint = [];
areas = [];
for n = 1 : N
    L = (seg1 == sid(n));
    t = L & bw;
    if sum(t(:)) / sum(L(:)) > 0.6 && sum(L(:)) > 300
       sregion = [sregion; sid(n)];
       [y,x] = find(L==1);
       spoint = [spoint; mean(x), mean(y)];
       areas = [areas; sum(L(:))];
    end
   
end   

save sregion.txt sregion -ascii
save points.txt spoint -ascii
save areas.txt areas -ascii

map = zeros(size(im1,1), size(im1,2));
for n = 1 : size(sregion,1)
    map = map + (seg1 == sregion(n)) * n;
end
    
seg2 = load('seg2.txt');
sid2 = unique(seg2);
K = size(sid2,1);

tpoint = [];
areat = [];
for k = 1 : K
       L = (seg2 == sid2(k));
       [y,x] = find(L==1);
       areat = [areat; sum(L(:))];
       tpoint = [tpoint; mean(x), mean(y)];
end   

save tpoint.txt tpoint -ascii
save areat.txt areat -ascii

cost = zeros(size(sregion,1), K);
im1x = rgb2hsv(im1);
im2x = rgb2hsv(im2);
for n = 1 : size(sregion,1)
    S = (seg1 == sregion(n));
    [y1,x1] = find(S == 1);
    r1 = shapeeig(x1, y1);
    imr = im1x(:,:,1);
    sr = mean(imr(S));
    sr_d = std(imr(S));
    img = im1x(:,:,2);
    sg = mean(img(S));
    sg_d = std(img(S));
    imb = im1x(:,:,3);
    sb = mean(imb(S));
    sb_d = std(imb(S));
    sm = sr + sg + sb + 0.001;
    ssr = sr/sm;
    ssg = sg/sm;
    ssb = sb/sm;
    ss = sum(S(:));

    for k = 1 : K
      T = (seg2 == sid2(k));
      [y2,x2] = find(T == 1);
      r2 = shapeeig(x2, y2);
      imr = im2x(:,:,1);
      tr = mean(imr(T));
      tr_d = std(imr(T));

      img = im2x(:,:,2);
      tg = mean(img(T));
      tg_d = std(img(T));

      imb = im2x(:,:,3);
      tb = mean(imb(T));
      tb_d = std(imb(T));

      ts = sum(T(:));
      tm = tr + tg + tb + 0.001;
      ttr = tr/tm;
      ttg = tg/tm;
      ttb = tb/tm;
      if ss/ts > 10 || ts/ss > 10  
          cost(n, k) = 1000;
      else
          cost(n, k) =   1*abs(r1-r2) +...
                         0*abs(sr_d-tr_d)+abs(sg_d-tg_d)+abs(sb_d-tb_d) +...
                         + 1*(abs(ssr-ttr)+abs(ssg-ttg)+abs(ssb-ttb)) +...
                         0.2*(abs(sr-tr)+abs(sg-tg)+abs(sb-tb)); 
      end
    end
end

save cost.txt cost -ascii
 
for pid = 1 : size(sregion,1)    
   tname = sprintf('pointt%d.txt', pid);
   fd = fopen(tname, 'wt');
   txname = sprintf('pointt%dx.txt', pid);
   fdx = fopen(txname, 'wt');
   fprintf(fd, '%d\n', size(tpoint,1));
   for n = 1 : size(tpoint,1)
     fprintf(fd, '%f %f\n', tpoint(n,1), tpoint(n,2));
     fprintf(fdx, '%f %f\n', tpoint(n,1), tpoint(n,2));
   end
   fclose(fd);
   fclose(fdx);

   cname = sprintf('cost%d.txt', pid);
   fd = fopen(cname, 'wt');
   fprintf(fd, '%d ', size(cost,2));
   for n = 1 : size(cost,2)
      fprintf(fd, '%f ', cost(pid, n));
   end
   fclose(fd);
end

% Define a simple star structure       
x = mean(spoint(:,1));
y = mean(spoint(:,2));
d  = sum(abs(spoint - repmat([x,y], size(spoint,1), 1)), 2);
[y, id] = min(d);

fd = fopen('pair.txt', 'wt');
for n = 1 : size(spoint,1)
    if n ~= id
       fprintf(fd, '%d %d\n', id, n);
    end
end
fclose(fd);
      
