y = load('z.txt');
ps = unique(y(:,1));
ps = sort(ps); 
id = [];

for n = 1 : size(ps,1)
   r = find(y(:,1) == ps(n));
   [v, ind] = max(y(r,3));
   z = y(r,:);
   coord = [z(ind,1) z(ind,2)];
   id = [id; coord];
end

spoint = load('points.txt');
rcolor = rand(size(spoint,1), 3)*0.5+0.5;
im = imread('image2.ppm');
im = im2double(im);

for n = 1 : size(id,1)
  fname = sprintf('pointt%dx.txt', n);
  ptt{n} = load(fname);
end

seg2 = load('seg2.txt');
sid2 = unique(seg2);
red = im(:,:,1);
green = im(:,:,2);
blue = im(:,:,3);
[tx,ty] = gradient(seg2);
T = abs(tx)+abs(ty) > 0;
red(T) = 0.25;
green(T) = 0.25;
blue(T) = 0.25;


xy = [];
for n = 1 : size(id,1)
   xy = [xy; ptt{id(n,1)}(id(n,2),1), ptt{id(n,1)}(id(n,2),2)];
end 

for m = 1 : size(xy,1)
 for n = 1 : length(sid2)
    L = seg2 == sid2(n);
    [my, mx] = find(L);
    my = mean(my);
    mx = mean(mx);
    
    mv = min(abs(xy(m,1)-mx) + abs(xy(m,2)-my));
    if (mv <= 3) 
      red(L) = rcolor(m,1);
      green(L) = rcolor(m,2);
      blue(L) = rcolor(m,3);
    end
    im = cat(3, red, green, blue);
  end
end

figure(2);
imshow(im)
hold on;

for n = 1 : size(id,1)
    h = plot(ptt{id(n,1)}(id(n,2),1), ptt{id(n,1)}(id(n,2),2), 'r.');
    set(h, 'markersize', 20);
    num = sprintf('%d', n);
    text(ptt{id(n,1)}(id(n,2),1), ptt{id(n,1)}(id(n,2),2), num, 'Color', [0,0,1], 'FontSize', 25);
end

tx = [];
ty = [];
for n = 1 : size(id,1)
    tx = [tx; ptt{id(n,1)}(id(n,2),1)];
    ty = [ty; ptt{id(n,1)}(id(n,2),2)];
end

ps = load('points.txt');
%tri = delaunay(ps(:,1), ps(:,2), {'QJ'});
%triplot(tri, tx, ty, 'color', 'm');

hold off;
  
figure(1);
seg1 = load('seg1.txt');
sid1 = unique(seg1);
im1 = imread('image1.ppm');
im1 = im2double(im1);
red = im1(:,:,1);
green = im1(:,:,2);
blue = im1(:,:,3);

[tx,ty] = gradient(seg1);
T = abs(tx)+abs(ty) > 0;
red(T) = 0.25;
green(T) = 0.25;
blue(T) = 0.25;

for m = 1 : size(ps,1)
 for n = 1 : length(sid1)
    L = seg1 == sid1(n);
    [my, mx] = find(L);
    my = mean(my);
    mx = mean(mx);

    mv = min(abs(ps(m,1)-mx) + abs(ps(m,2)-my));
    if (mv <= 3)
      red(L) = rcolor(m,1);
      green(L) = rcolor(m,2);
      blue(L) = rcolor(m,3);
    end
    im1 = cat(3, red, green, blue);
  end
end

imshow(im1);
hold on;
plot(ps(:,1), ps(:,2), '+');
%triplot(tri, ps(:,1), ps(:,2), 'color', 'm');
for n = 1 : size(ps,1)
    num = sprintf('%d', n);
    text(ps(n,1), ps(n,2), num, 'Color', 1-rcolor(n,:), 'FontSize', 16);
end

hold off;

    
